define("nexus-ldap-plugin-boot",["Sonatype/repoServer/LdapContainer"],function(){Nexus.Log.debug("Enterprise LDAP plugin loaded")});
NX.define("Sonatype.repoServer.LdapConfigurationUserGroup",{extend:"Ext.Panel",requires:["Sonatype.repoServer.LdapUserMappingPanel","Sonatype.repoServer.LdapLoginTestWindow"],constructor:function(cfg){var config=cfg||{};var defaultConfig={fieldWidth:200};Ext.apply(this,config,defaultConfig);var groupTypeStore=new Ext.data.SimpleStore({fields:["value","display"],data:[["dynamic","Dynamic Groups"],["static","Static Groups"]]});var templateStore=new Ext.data.JsonStore({root:"data",id:"name",fields:[{name:"name",sortType:Ext.data.SortTypes.asUCString},{name:"userAndGroupConfig"}],url:Sonatype.config.servicePath+"/ldap/templates",autoLoad:true,sortInfo:{field:"name",direction:"asc"}});Sonatype.repoServer.LdapConfigurationUserGroup.superclass.constructor.call(this,{items:[{xtype:"fieldset",checkboxToggle:false,title:"User & Group Templates",labelWidth:188,collapsible:true,collapsed:false,autoHeight:true,items:[{xtype:"combo",fieldLabel:"Template",helpText:"Select a template to apply some default values to the configuration.",name:"template",width:this.fieldWidth,store:templateStore,valueField:"name",displayField:"name",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select a Template to apply...",selectOnFocus:true,listeners:{select:{fn:this.templateSelectHandler,scope:this}}}]},{xtype:"fieldset",checkboxToggle:false,title:"User Element Mapping",labelWidth:188,collapsible:true,autoHeight:true,items:[{xtype:"textfield",fieldLabel:"Base DN",helpText:'Base location in the LDAP that the users are found, relative to the search base ("ou=people").',name:"userAndGroupConfig.userBaseDn",width:this.fieldWidth,allowBlank:true},{xtype:"checkbox",fieldLabel:"User Subtree",helpText:"Check this box if users are located in structures below the user Base DN. If all users are located in ou=people,dc=example,dc=com, this value should be false. If users are located in organizations such as ou=development,ou=people,dc=example,dc=com, this value should be true.",name:"userAndGroupConfig.userSubtree"},{xtype:"textfield",fieldLabel:"Object Class",helpText:'LDAP class for user objects ("inetOrgPerson").',name:"userAndGroupConfig.userObjectClass",width:this.fieldWidth,itemCls:"required-field",allowBlank:false},{xtype:"textfield",fieldLabel:"User Filter",helpText:'LDAP search filter to additionally limit user search (for example "attribute=foo" or "(|(mail=*@domain.com)(uid=dom*))".',name:"userAndGroupConfig.ldapFilter",width:this.fieldWidth,allowBlank:true},{xtype:"textfield",fieldLabel:"User ID Attribute",helpText:'LDAP attribute containing user id ("userIdAttribute").',name:"userAndGroupConfig.userIdAttribute",width:this.fieldWidth,itemCls:"required-field",allowBlank:false},{xtype:"textfield",fieldLabel:"Real Name Attribute",helpText:'LDAP attribute containing the real name of the user ("cn").',name:"userAndGroupConfig.userRealNameAttribute",width:this.fieldWidth,itemCls:"required-field",allowBlank:false},{xtype:"textfield",fieldLabel:"E-Mail Attribute",helpText:'LDAP attribute containing e-mail address ("emailAddressAttribute").',name:"userAndGroupConfig.emailAddressAttribute",width:this.fieldWidth,itemCls:"required-field",allowBlank:false}]},{xtype:"fieldset",checkboxToggle:true,labelWidth:188,collapsed:true,title:"Use Password Attribute",autoHeight:true,listeners:{expand:{fn:function(panel){this.ldapConfigurationContainer.expandHandler(panel)},scope:this},collapse:{fn:function(panel){this.find("name","userAndGroupConfig.userPasswordAttribute")[0].setValue(null);this.ldapConfigurationContainer.collapseHandler(panel)},scope:this,delay:100}},items:[{xtype:"textfield",fieldLabel:"Password Attribute",helpText:'LDAP attribute containing the password ("userPassword").  If this field is blank the user will be authenticated against a bind with the LDAP server.',name:"userAndGroupConfig.userPasswordAttribute",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"}]},{xtype:"fieldset",checkboxToggle:true,labelWidth:188,collapsed:false,title:"Group Element Mapping",autoHeight:true,listeners:{expand:{fn:function(panel){this.find("name","userAndGroupConfig.ldapGroupsAsRoles")[0].setValue(true);this.ldapConfigurationContainer.expandHandler(panel)},scope:this},collapse:{fn:function(panel){this.find("name","userAndGroupConfig.ldapGroupsAsRoles")[0].setValue(false);this.ldapConfigurationContainer.collapseHandler(panel)},scope:this,delay:100}},items:[{xtype:"combo",itemCls:"required-field",fieldLabel:"Group Type",helpText:"The type of group to use, static or dynamic.",name:"groupType",width:this.fieldWidth,store:groupTypeStore,valueField:"value",displayField:"display",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,listeners:{select:{fn:this.groupTypeSelectHandler,scope:this}}},{xtype:"textfield",fieldLabel:"Base DN",helpText:'Base location in the LDAP that the groups are found, relative to the search base ("ou=Group").',name:"userAndGroupConfig.groupBaseDn",width:this.fieldWidth,allowBlank:true,hideParent:true},{xtype:"checkbox",fieldLabel:"Group Subtree",helpText:"Check this box if groups are located in structures below the group Base DN. If all groups are located in ou=group,dc=example,dc=com, this value should be false. If groups are located in organizations such as ou=devgroups,ou=groups,dc=example,dc=com, this value should be true.",name:"userAndGroupConfig.groupSubtree",hideParent:true},{xtype:"textfield",fieldLabel:"Object Class",helpText:'LDAP class for group objects ("posixGroup").',name:"userAndGroupConfig.groupObjectClass",width:this.fieldWidth,itemCls:"required-field",allowBlank:false,hideParent:true},{xtype:"textfield",fieldLabel:"Group ID Attribute",helpText:'LDAP attribute containing group id ("cn").',name:"userAndGroupConfig.groupIdAttribute",width:this.fieldWidth,itemCls:"required-field",allowBlank:false,hideParent:true},{xtype:"textfield",fieldLabel:"Group Member Attribute",helpText:"LDAP attribute containing the usernames for the group.",name:"userAndGroupConfig.groupMemberAttribute",width:this.fieldWidth,itemCls:"required-field",allowBlank:false,hideParent:true},{xtype:"textfield",fieldLabel:"Group Member Format",helpText:'The format of User ID stored in the Group Member Attribute. A token "${dn}" can be used to lookup the FQDN of the user or use something like "uid=${username},ou=people,o=sonatype" where "${username}" is replaced with the Username value.',name:"userAndGroupConfig.groupMemberFormat",width:this.fieldWidth,itemCls:"required-field",allowBlank:false,hideParent:true},{xtype:"textfield",fieldLabel:"Member of Attribute",helpText:"Groups are generally one of two types in LDAP systems - static or dynamic. A static group maintains its own membership list. A dynamic group records its membership on a user entry. If dynamic groups this should be set to the attribute used to store the attribute that holds groups DN in the user object.",name:"userAndGroupConfig.userMemberOfAttribute",width:this.fieldWidth,itemCls:"required-field",allowBlank:false,hideParent:true},{xtype:"checkbox",hidden:true,hideLabel:true,height:0,name:"userAndGroupConfig.ldapGroupsAsRoles",checked:true}]}],listeners:{afterlayout:{fn:function(){this.isLoaded=true},scope:this}}})},postLoad:function(){if(!this.ldapConfigurationContainer.isNew){this.find("name","template")[0].ownerCt.collapse();var ldapGroupsAsRoles=this.find("name","userAndGroupConfig.ldapGroupsAsRoles")[0];if(!ldapGroupsAsRoles.getValue()){ldapGroupsAsRoles.ownerCt.collapse()}var userPassAttrib=this.find("name","userAndGroupConfig.userPasswordAttribute")[0];if(Ext.isEmpty(userPassAttrib.getValue())){userPassAttrib.ownerCt.collapse()}else{userPassAttrib.ownerCt.expand()}if(Ext.isEmpty(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0].getValue())){this.find("name","groupType")[0].setValue("static");this.hideComponent(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupBaseDn")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupSubtree")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupObjectClass")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupIdAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupMemberAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupMemberFormat")[0])}else{this.find("name","groupType")[0].setValue("dynamic");this.showComponent(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupBaseDn")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupSubtree")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupObjectClass")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupIdAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupMemberAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupMemberFormat")[0])}}},applyFieldValue:function(field,value){field.setValue(value);field.clearInvalid()},groupTypeSelectHandler:function(combo,record,index){var newValue=combo.getValue();if(newValue=="static"){this.find("name","userAndGroupConfig.userMemberOfAttribute")[0].setValue("");this.hideComponent(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupBaseDn")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupSubtree")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupObjectClass")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupIdAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupMemberAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupMemberFormat")[0])}else{this.showComponent(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupBaseDn")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupSubtree")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupObjectClass")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupIdAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupMemberAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupMemberFormat")[0])}this.doLayout()},templateSelectHandler:function(combo,record,index){var data=record.data.userAndGroupConfig;this.applyFieldValue(this.find("name","userAndGroupConfig.userBaseDn")[0],data.userBaseDn);this.applyFieldValue(this.find("name","userAndGroupConfig.userSubtree")[0],data.userSubtree);this.applyFieldValue(this.find("name","userAndGroupConfig.userObjectClass")[0],data.userObjectClass);this.applyFieldValue(this.find("name","userAndGroupConfig.userIdAttribute")[0],data.userIdAttribute);this.applyFieldValue(this.find("name","userAndGroupConfig.userRealNameAttribute")[0],data.userRealNameAttribute);this.applyFieldValue(this.find("name","userAndGroupConfig.emailAddressAttribute")[0],data.emailAddressAttribute);this.applyFieldValue(this.find("name","userAndGroupConfig.userPasswordAttribute")[0],data.userPasswordAttribute);this.applyFieldValue(this.find("name","userAndGroupConfig.groupBaseDn")[0],data.groupBaseDn);this.applyFieldValue(this.find("name","userAndGroupConfig.groupSubtree")[0],data.groupSubtree);this.applyFieldValue(this.find("name","userAndGroupConfig.groupObjectClass")[0],data.groupObjectClass);this.applyFieldValue(this.find("name","userAndGroupConfig.groupIdAttribute")[0],data.groupIdAttribute);this.applyFieldValue(this.find("name","userAndGroupConfig.groupMemberAttribute")[0],data.groupMemberAttribute);this.applyFieldValue(this.find("name","userAndGroupConfig.groupMemberFormat")[0],data.groupMemberFormat);this.applyFieldValue(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0],data.userMemberOfAttribute);if(Ext.isEmpty(data.userMemberOfAttribute)){this.find("name","groupType")[0].setValue("static");this.hideComponent(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupBaseDn")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupSubtree")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupObjectClass")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupIdAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupMemberAttribute")[0]);this.showComponent(this.find("name","userAndGroupConfig.groupMemberFormat")[0])}else{this.find("name","groupType")[0].setValue("dynamic");this.showComponent(this.find("name","userAndGroupConfig.userMemberOfAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupBaseDn")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupSubtree")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupObjectClass")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupIdAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupMemberAttribute")[0]);this.hideComponent(this.find("name","userAndGroupConfig.groupMemberFormat")[0])}var ldapGroupsAsRoles=this.find("name","userAndGroupConfig.ldapGroupsAsRoles")[0];ldapGroupsAsRoles.setValue(data.ldapGroupsAsRoles);if(!data.ldapGroupsAsRoles){ldapGroupsAsRoles.ownerCt.collapse()}var ldapGroupsAsRoles=this.find("name","userAndGroupConfig.ldapGroupsAsRoles")[0];if(!ldapGroupsAsRoles.getValue()){ldapGroupsAsRoles.ownerCt.collapse()}var userPassAttrib=this.find("name","userAndGroupConfig.userPasswordAttribute")[0];if(Ext.isEmpty(userPassAttrib.getValue())){userPassAttrib.ownerCt.collapse()}else{userPassAttrib.ownerCt.expand()}},hideComponent:function(component){component.disable();component.hide()},showComponent:function(component){component.enable();component.show()},handleButtons:function(){this.ldapConfigurationContainer.formPanel.buttons[0].hide();this.ldapConfigurationContainer.formPanel.buttons[1].show();this.ldapConfigurationContainer.formPanel.buttons[2].show()},checkUserMapping:function(formPanel,referenceData){var ldapServerId,isNew=this.ldapConfigurationContainer.isNew,params={userLimitCount:20,_dc:new Date().getTime()};if(!isNew){params.ldapServerId=this.ldapConfigurationContainer.record.get("id")}formPanel.getForm().doAction("sonatypeSubmit",{method:"PUT",url:Sonatype.config.servicePath+"/ldap/test_user_conf",waitMsg:"Checking user mapping...",fpanel:formPanel,params:params,dataModifiers:this.ldapConfigurationContainer.dataModifiers.submit,serviceDataObj:referenceData,autoValidation:false,success:function(form,action){var window=new Sonatype.repoServer.LdapUserMappingPanel({});window.populateStore(Ext.decode(action.response.responseText));window.show()},failure:function(form,action){Sonatype.utils.connectionError(action.response,"Error checking user mapping.",false,{hideErrorStatus:true,decodeErrorResponse:true})}})},checkLogin:function(formPanel,referenceData){var window=new Sonatype.repoServer.LdapLoginTestWindow({formPanel:formPanel,referenceData:referenceData,ldapConfigurationContainer:this.ldapConfigurationContainer});window.show()}});
NX.define("Sonatype.repoServer.LdapUserMappingPanel",{extend:"Ext.Window",constructor:function(cfg){var config=cfg||{},defaultConfig={title:"User Mapping Test Results",layout:"fit",height:400,width:600,autoScroll:true};Ext.apply(this,config,defaultConfig);this.userRecordConstructor=Ext.data.Record.create([{name:"userId",sortType:Ext.data.SortTypes.asUCString},{name:"name"},{name:"email"},{name:"roles"},{name:"displayRoles",mapping:"roles",convert:this.joinRoles.createDelegate(this)}]);this.usersReader=new Ext.data.JsonReader({root:"data",id:"userId"},this.userRecordConstructor);this.usersDataStore=new Ext.data.Store({reader:this.usersReader,sortInfo:{field:"userId",direction:"ASC"},autoLoad:false});this.usersGridPanel=new Ext.grid.GridPanel({frame:false,autoScroll:true,ds:this.usersDataStore,sortInfo:{field:"userId",direction:"asc"},loadMask:true,height:400,width:650,deferredRender:false,columns:[{header:"User ID",dataIndex:"userId",width:100,id:"user-config-userid-col"},{header:"Name",dataIndex:"name",width:175,id:"user-config-name-col"},{header:"Email",dataIndex:"email",width:175,id:"user-config-email-col"},{header:"Roles",dataIndex:"displayRoles",width:175,id:"user-config-roles-col"}],disableSelection:true,viewConfig:{emptyText:"No user records found."}});Sonatype.repoServer.LdapUserMappingPanel.superclass.constructor.call(this,{modal:true,items:[this.usersGridPanel],buttonAlign:"center",buttons:[{text:"Close",handler:function(){this.close()},scope:this}]})},populateStore:function(data){this.usersDataStore.loadData(data?data:{data:[]})},joinRoles:function(value,parent){var s="";for(var i=0;i<value.length;i++){if(i>0){s+=", "}s+=value[i]}return s}});
NX.define("Sonatype.repoServer.LdapConfigurationConnection",{extend:"Ext.Panel",constructor:function(cfg){var config=cfg||{};Ext.apply(this,config,{});var protocolStore=new Ext.data.SimpleStore({fields:["value"],data:[["ldap"],["ldaps"]]});var authenticationMethodStore=new Ext.data.SimpleStore({fields:["value","display"],data:[["simple","Simple Authentication"],["none","Anonymous Authentication"],["DIGEST-MD5","DIGEST-MD5"],["CRAM-MD5","CRAM-MD5"]]});Sonatype.repoServer.LdapConfigurationConnection.superclass.constructor.call(this,{items:[{xtype:"fieldset",title:"Connection",items:[{xtype:"textfield",fieldLabel:"Name",helpText:"The name of the LDAP Server.",name:"name",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"},{xtype:"combo",fieldLabel:"Protocol",itemCls:"required-field",helpText:"Use plain text (ldap://) or secure (ldaps://) connection.",name:"connectionInfo.protocol",width:this.fieldWidth,store:protocolStore,valueField:"value",displayField:"value",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,listeners:{select:{fn:function(combo,record,index){var newValue=combo.getValue();var port=this.find("name","connectionInfo.port")[0];var portValue=port.getRawValue();if(newValue=="ldap"&&(portValue==636||portValue==0)){port.setValue(389)}else{if(newValue=="ldaps"&&(portValue==389||portValue==0)){port.setValue(636)}}},scope:this}}},{xtype:"textfield",fieldLabel:"Hostname",helpText:"The host name of the LDAP server.",name:"connectionInfo.host",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"},{xtype:"numberfield",fieldLabel:"Port",helpText:"The port the LDAP server is listening on (ldap - 389, ldaps - 636).",name:"connectionInfo.port",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"},{xtype:"textfield",fieldLabel:"Search Base",helpText:'LDAP location to be added to the connection URL, e.g. "dc=sonatype,dc=com".',name:"connectionInfo.searchBase",width:this.fieldWidth,itemCls:"required-field",allowBlank:false}]},{xtype:"fieldset",labelWidth:188,checkboxToggle:false,title:"Authentication",collapsible:true,autoHeight:true,items:[{xtype:"combo",fieldLabel:"Authentication Method",itemCls:"required-field",helpText:"Authentication method.",name:"connectionInfo.authScheme",width:this.fieldWidth,store:authenticationMethodStore,valueField:"value",displayField:"display",editable:false,forceSelection:true,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,listeners:{select:{fn:this.authenticationMethodSelectHandler,scope:this}}},{xtype:"textfield",fieldLabel:"SASL Realm",helpText:'The SASL realm to bind to, e.g. "mydomain.com".',name:"connectionInfo.realm",width:this.fieldWidth,allowBlank:true},{xtype:"textfield",fieldLabel:"Username",helpText:"The username or DN to bind with. If simple authentication is used, this has to be a fully qualified user name.",name:"connectionInfo.systemUsername",width:this.fieldWidth,allowBlank:true},{xtype:"textfield",fieldLabel:"Password",inputType:"password",helpText:"The password to bind with.",name:"connectionInfo.systemPassword",width:this.fieldWidth,allowBlank:true}]},{xtype:"fieldset",checkboxToggle:false,title:"Timeouts",labelWidth:188,collapsible:true,autoHeight:true,items:[{xtype:"numberfield",fieldLabel:"Connection Timeout",helpText:"The number of seconds to wait before timeout on connection to LDAP Server.",name:"connectionInfo.connectionTimeout",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"},{xtype:"numberfield",fieldLabel:"Retry Delay",helpText:"The number of seconds to wait before retrying a request to the LDAP Server.",name:"connectionInfo.connectionRetryDelay",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"}]},{xtype:"fieldset",checkboxToggle:true,title:"Cache",labelWidth:188,autoHeight:true,listeners:{expand:{fn:function(panel){this.ldapConfigurationContainer.expandHandler(panel)},scope:this},collapse:{fn:function(panel){this.find("name","connectionInfo.cacheTimeout")[0].setValue(0);this.ldapConfigurationContainer.collapseHandler(panel)},scope:this,delay:100}},items:[{xtype:"numberfield",fieldLabel:"Cache Duration",helpText:"The number of seconds to keep items in the cache.",name:"connectionInfo.cacheTimeout",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"}]}],listeners:{afterlayout:{fn:function(){this.isLoaded=true},scope:this}}})},postLoad:function(){if(this.ldapConfigurationContainer.isNew){this.find("name","connectionInfo.connectionTimeout")[0].setValue(30);this.find("name","connectionInfo.connectionRetryDelay")[0].setValue(300);this.find("name","connectionInfo.cacheTimeout")[0].setValue(600)}else{this.authenticationMethodSelectHandler(this.find("name","connectionInfo.authScheme")[0]);var cacheDur=this.find("name","connectionInfo.cacheTimeout")[0];if(cacheDur.getValue()>0){cacheDur.ownerCt.expand()}else{cacheDur.ownerCt.collapse()}}},authenticationMethodSelectHandler:function(combo,record,index){if(combo.getValue()=="simple"){this.find("name","connectionInfo.realm")[0].disable();this.find("name","connectionInfo.systemUsername")[0].enable();this.find("name","connectionInfo.systemPassword")[0].enable()}else{if(combo.getValue()=="none"){this.find("name","connectionInfo.realm")[0].disable();this.find("name","connectionInfo.systemUsername")[0].disable();this.find("name","connectionInfo.systemUsername")[0].setValue("");this.find("name","connectionInfo.systemPassword")[0].disable();this.find("name","connectionInfo.systemPassword")[0].setValue("")}else{if(combo.getValue()=="DIGEST-MD5"){this.find("name","connectionInfo.realm")[0].enable();this.find("name","connectionInfo.systemUsername")[0].enable();this.find("name","connectionInfo.systemPassword")[0].enable()}else{if(combo.getValue()=="CRAM-MD5"){this.find("name","connectionInfo.realm")[0].enable();this.find("name","connectionInfo.systemUsername")[0].enable();this.find("name","connectionInfo.systemPassword")[0].enable()}}}}},handleButtons:function(){this.ldapConfigurationContainer.formPanel.buttons[0].show();this.ldapConfigurationContainer.formPanel.buttons[1].hide();this.ldapConfigurationContainer.formPanel.buttons[2].hide()},checkAuthentication:function(){var params,ldapServerId=this.ldapConfigurationContainer.record.get("id"),isNew=this.ldapConfigurationContainer.isNew;if(!isNew){params={ldapServerId:ldapServerId}}Sonatype.MessageBox.wait("Checking LDAP Authentication...");Ext.Ajax.request({method:"PUT",url:Sonatype.config.servicePath+"/ldap/test_auth",params:params,jsonData:{data:{protocol:this.find("name","connectionInfo.protocol")[0].getValue(),host:this.find("name","connectionInfo.host")[0].getValue(),port:this.find("name","connectionInfo.port")[0].getValue(),searchBase:this.find("name","connectionInfo.searchBase")[0].getValue(),authScheme:this.find("name","connectionInfo.authScheme")[0].getValue(),realm:this.find("name","connectionInfo.realm")[0].getValue(),systemUsername:Sonatype.utils.base64.encode(this.find("name","connectionInfo.systemUsername")[0].getValue()),systemPassword:Sonatype.utils.base64.encode(this.find("name","connectionInfo.systemPassword")[0].getValue()),connectionTimeout:this.find("name","connectionInfo.connectionTimeout")[0].getValue(),connectionRetryDelay:this.find("name","connectionInfo.connectionRetryDelay")[0].getValue(),cacheTimeout:this.find("name","connectionInfo.cacheTimeout")[0].getValue()}},callback:function(options,success,response){if(success){Sonatype.MessageBox.alert("Check Authentication","LDAP connection and authentication test completed successfully.").setIcon(Sonatype.MessageBox.INFO)}else{Sonatype.utils.connectionError(response,"LDAP connection and authentication test failed.",false,{hideErrorStatus:true,decodeErrorResponse:true})}}})}});
NX.define("Sonatype.repoServer.LdapGrid",{extend:"Ext.grid.GridPanel",requires:["Nexus.ext.GridFilterBox"],constructor:function(cfg){var config=cfg||{};var defaultConfig={};Ext.apply(this,config,defaultConfig);this.store=new Ext.data.JsonStore({root:"data",id:"url",fields:[{name:"id",sortType:Ext.data.SortTypes.asUCString},{name:"name",sortType:Ext.data.SortTypes.asUCString},{name:"url",sortType:Ext.data.SortTypes.asUCString},{name:"ldapUrl",sortType:Ext.data.SortTypes.asUCString}],url:Sonatype.config.servicePath+"/ldap/servers",autoLoad:true,sortInfo:{field:"name",direction:"asc"},listeners:{beforeload:this.rememberSelection,load:this.recallSelection,scope:this}});this.recordConstructor=Ext.data.Record.create([{name:"id"},{name:"name"},{name:"url"},{name:"ldapUrl"}]);this.autoExpandColumn="urlColumn";this.columns=[{header:"Name",dataIndex:"name",width:200,sortable:true},{id:"urlColumn",header:"URL",dataIndex:"ldapUrl",width:300,sortable:true}];this.tbar=[{text:"Refresh",icon:Sonatype.config.resourcePath+"/images/icons/arrow_refresh.png",cls:"x-btn-text-icon",scope:this,handler:this.refreshHandler},{text:"Add",icon:Sonatype.config.resourcePath+"/images/icons/add.png",cls:"x-btn-text-icon",scope:this,handler:this.addHandler,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.CREATE)},{text:"Delete",icon:Sonatype.config.resourcePath+"/images/icons/delete.png",cls:"x-btn-text-icon",scope:this,handler:this.deleteHandler,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.DELETE)}," "," "," ","-"," "," "," ",{text:"Move Up",icon:Sonatype.config.resourcePath+"/static/images/move-up.gif",cls:"x-btn-text-icon",tooltip:{title:"LDAP Server Ordering",text:"Move the LDAP Server up in the list priority."},scope:this,handler:this.moveUpHandler,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.EDIT)},{text:"Move Down",icon:Sonatype.config.resourcePath+"/static/images/move-down.gif",cls:"x-btn-text-icon",tooltip:{title:"LDAP Server Ordering",text:"Move the LDAP Server down in the list priority."},scope:this,handler:this.moveDownHandler,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.EDIT)},{text:"Save Order",icon:Sonatype.config.extPath+"/resources/images/default/dd/drop-yes.gif",cls:"x-btn-text-icon",tooltip:{title:"LDAP Server Ordering",text:"Save the current LDAP Server priority order."},scope:this,handler:this.saveOrderHandler,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.EDIT)}," "," "," ","-"," "," "," ",{text:"Clear Cache",icon:Sonatype.config.resourcePath+"/images/icons/user-trash.png",cls:"x-btn-text-icon",tooltip:{title:"Clear LDAP Cache",text:"Clear the current cache of LDAP authentication and authorization credentials."},scope:this,handler:this.clearCacheHandler,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.DELETE)}];Sonatype.repoServer.LdapGrid.superclass.constructor.call(this,{viewConfig:{emptyText:"No LDAP servers",emptyTextWhileFiltering:"No LDAP servers matched criteria: {criteria}"},sm:new Ext.grid.RowSelectionModel({singleSelect:true}),listeners:{rowclick:{fn:this.rowclickHandler,scope:this},afterrender:function(cmp){var mask=new Ext.LoadMask(cmp.getGridEl(),{store:this.store})}}});this.getTopToolbar().add(["->",NX.create("Nexus.ext.GridFilterBox",{filteredGrid:this})])},updateRecord:function(id,jsonData){var rec=this.store.getById(id);this.store.remove(rec);rec.id=jsonData.id;rec.data.id=jsonData.id;rec.data.name=jsonData.name;rec.data.url=jsonData.url;rec.data.ldapUrl=jsonData.connectionInfo.protocol+"://"+jsonData.connectionInfo.host+":"+jsonData.connectionInfo.port+"/"+jsonData.connectionInfo.searchBase;this.store.add(rec);this.store.sort("name","ASC");this.getSelectionModel().selectRecords([rec],false);return rec},refreshHandler:function(){this.store.reload();this.ldapContainer.refresh()},addHandler:function(){var id="new_"+new Date().getTime();var newRec=new this.recordConstructor({name:"New LDAP",id:id,url:"new",ldapUrl:"Not Available"},id);this.store.insert(0,[newRec]);this.getSelectionModel().selectRecords([newRec],false);if(this.ldapAddHandler){this.ldapAddHandler.call(this.ldapContainer,this,newRec)}},deleteHandler:function(){var record=this.getSelectionModel().getSelected();if(record.get("id").indexOf("new_")==-1){Sonatype.utils.defaultToNo();Sonatype.MessageBox.show({animEl:this.getEl(),title:"Delete",msg:'Delete LDAP Server "'+record.get("name")+'"?',buttons:Sonatype.MessageBox.YESNO,scope:this,icon:Sonatype.MessageBox.QUESTION,fn:function(btnName){if(btnName=="yes"||btnName=="ok"){Ext.Ajax.request({url:record.get("url"),callback:this.deleteCallback,cbPassThru:{record:record},scope:this,method:"DELETE"})}}})}else{this.deleteCallback({cbPassThru:{record:record}},true)}},deleteCallback:function(options,isSuccess,response){if(isSuccess){var record=options.cbPassThru.record;this.getStore().remove(record);if(this.ldapDeleteHandler){this.ldapDeleteHandler.call(this.ldapContainer,this,record)}}else{Sonatype.utils.connectionError(response,"Error Deleting LDAP Configuration.")}},rowclickHandler:function(grid,rowindex,event){if(this.ldapRowclickHandler){this.ldapRowclickHandler.call(this.ldapContainer,this,this.getStore().getAt(rowindex))}},moveUpHandler:function(){if(this.getSelectionModel().hasSelection()){var rec=this.getSelectionModel().getSelected();if(rec){var i=this.store.indexOf(rec);if(i>0){this.store.remove(rec);this.store.insert(i-1,rec);this.getSelectionModel().selectRecords([rec],false)}}}},moveDownHandler:function(){if(this.getSelectionModel().hasSelection()){var rec=this.getSelectionModel().getSelected();if(rec){var i=this.store.indexOf(rec);if(i<(this.store.getCount()-1)){this.store.remove(rec);this.store.insert(i+1,rec);this.getSelectionModel().selectRecords([rec],false)}}}},saveOrderHandler:function(){var idList=[];for(var i=0;i<this.store.getCount();i++){var rec=this.store.getAt(i);if(rec.get("id").indexOf("new_")==-1){idList[idList.length]=rec.get("id")}}Sonatype.utils.defaultToNo();Sonatype.MessageBox.show({animEl:this.getEl(),title:"Save LDAP Server Order",msg:"Save the current order of the LDAP Servers?",buttons:Sonatype.MessageBox.YESNO,scope:this,icon:Sonatype.MessageBox.QUESTION,fn:function(btnName){if(btnName=="yes"||btnName=="ok"){Ext.Ajax.request({callback:function(options,isSuccess,response){if(!isSuccess){Sonatype.utils.connectionError(response,"The server did not save the order of the LDAP Servers.")}},scope:this,method:"PUT",url:Sonatype.config.servicePath+"/ldap/server_order",jsonData:{data:idList}})}}})},clearCacheHandler:function(){Sonatype.MessageBox.wait("Clearing LDAP cache...");Ext.Ajax.request({url:Sonatype.config.servicePath+"/ldap/clearcache",callback:function(options,isSuccess,response){if(isSuccess){Sonatype.MessageBox.alert("Clear Cache","The LDAP cache has been cleared.").setIcon(Sonatype.MessageBox.INFO)}else{Sonatype.utils.connectionError(response,"The server did not clear the LDAP cache.")}},scope:this,method:"DELETE"})},rememberSelection:function(){this.selectedRecord=this.getSelectionModel().getSelected()},recallSelection:function(){var self=this;if(self.selectedRecord===undefined){return}self.ldapRowclickHandler.call(self.ldapContainer,self,self.selectedRecord)}});
NX.define("Sonatype.repoServer.LdapContainer",{extend:"Ext.Panel",requires:["Sonatype.repoServer.LdapGrid","Sonatype.repoServer.LdapConfiguration"],constructor:function(cfg){var config=cfg||{},defaultConfig={title:"LDAP Configuration"};Ext.apply(this,config,defaultConfig);this.sp=Sonatype.lib.Permissions;this.ldapGrid=new Sonatype.repoServer.LdapGrid({ldapContainer:this,region:"center",ldapAddHandler:this.addHandler,ldapDeleteHandler:this.deleteHandler,ldapRowclickHandler:this.rowclickHandler,sp:this.sp});this.ldapConfigCards=new Ext.Panel({split:true,region:"south",height:Sonatype.view.mainTabPanel.getInnerHeight()*0.75,minHeight:200,deferredRender:false,autoScroll:false,layout:"card",activeItem:0,items:[{id:"default",border:false,html:'<div class="little-padding">Select an LDAP record to view the details.</div>'}]});Sonatype.repoServer.LdapContainer.superclass.constructor.call(this,{layout:"border",border:"false",items:[this.ldapGrid,this.ldapConfigCards]})},addHandler:function(grid,record){var panel=new Sonatype.repoServer.LdapConfiguration({ldapContainer:this,id:record.id,record:record,isNew:true,ldapSaveCompleteHandler:this.saveCompleteHandler,ldapCancelHandler:this.cancelHandler,sp:this.sp});this.ldapConfigCards.add(panel);this.ldapConfigCards.getLayout().setActiveItem(panel)},deleteHandler:function(grid,record){var panel=this.ldapConfigCards.findById(record.id);if(panel){this.ldapConfigCards.remove(panel,true);panel.destroy()}this.selectLastCard()},selectLastCard:function(){var panel=this.ldapConfigCards.items.last();this.ldapConfigCards.getLayout().setActiveItem(panel);if(this.ldapConfigCards.items.getCount()>1){var record=this.ldapGrid.store.getById(panel.id);this.ldapGrid.getSelectionModel().selectRecords([record],false)}else{this.ldapGrid.getSelectionModel().clearSelections()}},rowclickHandler:function(grid,record){var panel=this.ldapConfigCards.findById(record.id);if(panel){this.ldapConfigCards.getLayout().setActiveItem(panel)}else{panel=new Sonatype.repoServer.LdapConfiguration({record:record,ldapContainer:this,id:record.id,ldapSaveCompleteHandler:this.saveCompleteHandler,ldapCancelHandler:this.cancelHandler,sp:this.sp});this.ldapConfigCards.add(panel);this.ldapConfigCards.getLayout().setActiveItem(panel)}},saveCompleteHandler:function(configurationPanel,jsonResponse){this.ldapConfigCards.remove(configurationPanel,true);var id=configurationPanel.id;configurationPanel.id=jsonResponse.data.id;this.rowclickHandler(this.ldapGrid,this.ldapGrid.updateRecord(id,jsonResponse.data))},cancelHandler:function(configurationPanel){if(configurationPanel.isNew){this.ldapGrid.deleteHandler()}else{this.ldapConfigCards.remove(configurationPanel,true);configurationPanel.destroy();this.selectLastCard()}},refresh:function(){this.ldapConfigCards.getLayout().setActiveItem(0);while(this.ldapConfigCards.items.getCount()>1){var panel=this.ldapConfigCards.items.last();this.ldapConfigCards.remove(panel,true);panel.destroy()}}},function(){Sonatype.Events.addListener("nexusNavigationInit",function(nexusPanel){var sp=Sonatype.lib.Permissions;if(sp.checkPermission("security:ldapconfig",sp.READ)){nexusPanel.add({enabled:true,sectionId:"st-nexus-security",title:"Enterprise LDAP",tabId:"enterprise-ldap",tabCode:Sonatype.repoServer.LdapContainer})}})});
NX.define("Sonatype.repoServer.LdapLoginTestWindow",{extend:"Ext.Window",constructor:function(cfg){var config=cfg||{};Ext.apply(this,config,{});Sonatype.repoServer.LdapLoginTestWindow.superclass.constructor.call(this,{title:"Login Credentials",closable:true,autoWidth:false,width:350,autoHeight:true,modal:true,constrain:true,resizable:false,draggable:false,items:[{xtype:"form",labelWidth:110,frame:true,monitorValid:true,items:[{xtype:"panel",style:"padding-left: 70px; padding-bottom: 10px",html:"Enter credentials to test against the LDAP server."},{xtype:"textfield",fieldLabel:"Username",helpText:"A username expected to be in the LDAP server.",anchor:Sonatype.view.FIELD_OFFSET,name:"username",allowBlank:false,itemCls:"required-field"},{xtype:"textfield",inputType:"password",fieldLabel:"Password",helpText:"A password used to login the user in LDAP server.",anchor:Sonatype.view.FIELD_OFFSET,name:"password",allowBlank:false,itemCls:"required-field"}],buttons:[{text:"Test",formBind:true,scope:this,handler:function(){this.testHandler()}},{text:"Cancel",formBind:false,scope:this,handler:function(){this.cancelHandler()}}]}]})},testHandler:function(){var formSubmitter=new Ext.form.Action.sonatypeSubmit(this.formPanel.getForm(),{dataModifiers:this.ldapConfigurationContainer.dataModifiers.submit,serviceDataObj:this.referenceData}),formJson=Ext.decode(formSubmitter.serializeForm(this.formPanel,this.formPanel.getForm())),requestJson={data:{username:Sonatype.utils.base64.encode(this.find("name","username")[0].getValue()),password:Sonatype.utils.base64.encode(this.find("name","password")[0].getValue()),configuration:formJson.data}},params,isNew=this.ldapConfigurationContainer.isNew;if(!isNew){params={ldapServerId:this.ldapConfigurationContainer.record.get("id")}}Ext.Ajax.request({url:Sonatype.config.servicePath+"/ldap/logintest",method:"PUT",params:params,jsonData:requestJson,scope:this,success:function(response,options){Sonatype.MessageBox.alert("Check Login","LDAP login completed successfully.").setIcon(Sonatype.MessageBox.INFO)},failure:function(response,options){Sonatype.utils.connectionError(response,"Error checking login.",false,{hideErrorStatus:true,decodeErrorResponse:true})}})},cancelHandler:function(){this.close()}});
NX.define("Sonatype.repoServer.LdapConfigurationBackupMirror",{extend:"Ext.Panel",constructor:function(config){var config=config||{};var defaultConfig={fieldWidth:200};Ext.apply(this,config,defaultConfig);var protocolStore=new Ext.data.SimpleStore({fields:["value"],data:[["ldap"],["ldaps"]]});Sonatype.repoServer.LdapConfigurationBackupMirror.superclass.constructor.call(this,{items:[{xtype:"fieldset",checkboxToggle:true,title:"Use Backup Mirror",labelWidth:188,collapsed:false,autoHeight:true,allowBlank:false,itemCls:"required-field",listeners:{expand:{fn:function(panel){this.ldapConfigurationContainer.expandHandler(panel);if(this.ldapConfigurationContainer.tabPanel.getActiveTab().getId()==this.getId()){this.ldapConfigurationContainer.formPanel.buttons[0].show()}},scope:this},collapse:{fn:function(panel){this.find("name","connectionInfo.backupMirrorProtocol")[0].setValue(null);this.find("name","connectionInfo.backupMirrorHost")[0].setValue(null);this.find("name","connectionInfo.backupMirrorPort")[0].setValue(0);this.ldapConfigurationContainer.collapseHandler(panel);if(this.ldapConfigurationContainer.tabPanel.getActiveTab().getId()==this.getId()){this.ldapConfigurationContainer.formPanel.buttons[0].hide()}},scope:this,delay:100}},items:[{xtype:"combo",fieldLabel:"Protocol",helpText:"Use plain text (ldap://) or secure (ldaps://) connection.",name:"connectionInfo.backupMirrorProtocol",width:this.fieldWidth,store:protocolStore,valueField:"value",displayField:"value",editable:false,mode:"local",triggerAction:"all",emptyText:"Select...",selectOnFocus:true,allowBlank:false,itemCls:"required-field",listeners:{select:{fn:function(combo,record,index){var newValue=combo.getValue();var port=this.find("name","connectionInfo.backupMirrorPort")[0];var portValue=port.getRawValue();if(newValue=="ldap"&&(portValue==636||portValue==0)){port.setValue(389)}else{if(newValue=="ldaps"&&(portValue==389||portValue==0)){port.setValue(636)}}},scope:this}}},{xtype:"textfield",fieldLabel:"Hostname",helpText:"The host name of the LDAP server.",name:"connectionInfo.backupMirrorHost",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"},{xtype:"numberfield",fieldLabel:"Port",helpText:"The port the LDAP server is listening on (ldap - 389, ldaps - 636).",name:"connectionInfo.backupMirrorPort",width:this.fieldWidth,allowBlank:false,itemCls:"required-field"}]}],listeners:{afterlayout:{fn:function(){this.isLoaded=true},scope:this}}})},postLoad:function(){var port=this.find("name","connectionInfo.backupMirrorPort")[0];if(port.getValue()>0){port.ownerCt.expand()}else{port.setValue(0);port.ownerCt.collapse()}},handleButtons:function(){if(this.find("name","connectionInfo.backupMirrorProtocol")[0].ownerCt.collapsed==false){this.ldapConfigurationContainer.formPanel.buttons[0].show()}else{this.ldapConfigurationContainer.formPanel.buttons[0].hide()}this.ldapConfigurationContainer.formPanel.buttons[1].hide();this.ldapConfigurationContainer.formPanel.buttons[2].hide()},checkAuthentication:function(){Sonatype.MessageBox.wait("Checking LDAP Mirror Authentication...");Ext.Ajax.request({method:"PUT",url:Sonatype.config.servicePath+"/ldap/test_auth",jsonData:{data:{protocol:this.find("name","connectionInfo.backupMirrorProtocol")[0].getValue(),host:this.find("name","connectionInfo.backupMirrorHost")[0].getValue(),port:this.find("name","connectionInfo.backupMirrorPort")[0].getValue(),searchBase:this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.searchBase")[0].getValue(),authScheme:this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.authScheme")[0].getValue(),realm:this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.realm")[0].getValue(),systemUsername:Sonatype.utils.base64.encode(this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.systemUsername")[0].getValue()),systemPassword:Sonatype.utils.base64.encode(this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.systemPassword")[0].getValue()),connectionTimeout:this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.connectionTimeout")[0].getValue(),connectionRetryDelay:this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.connectionRetryDelay")[0].getValue(),cacheTimeout:this.ldapConfigurationContainer.connectionConfigTab.find("name","connectionInfo.cacheTimeout")[0].getValue()}},callback:function(options,success,response){if(success){Sonatype.MessageBox.alert("Check Mirror Authentication","LDAP Mirror connection and authentication test completed successfully.").setIcon(Sonatype.MessageBox.INFO)}else{Sonatype.utils.connectionError(response,"LDAP Mirror connection and authentication test failed.",false,{hideErrorStatus:true,decodeErrorResponse:true})}}})}});
NX.define("Sonatype.repoServer.LdapConfiguration",{extend:"Ext.Panel",requires:["Sonatype.repoServer.LdapConfigurationConnection","Sonatype.repoServer.LdapConfigurationBackupMirror","Sonatype.repoServer.LdapConfigurationUserGroup","Sonatype.repoServer.LdapConfigurationSSLCertificate"],constructor:function(cfg){var config=cfg||{},self=this;Ext.apply(this,config,{});var FIELD_WIDTH=400;this.connectionConfigTab=new Sonatype.repoServer.LdapConfigurationConnection({title:"Connection",fieldWidth:FIELD_WIDTH,ldapConfigurationContainer:this});this.mirrorConfigTab=new Sonatype.repoServer.LdapConfigurationBackupMirror({title:"Backup Mirror",fieldWidth:FIELD_WIDTH,ldapConfigurationContainer:this});this.userGroupConfigTab=new Sonatype.repoServer.LdapConfigurationUserGroup({title:"User & Group Settings",fieldWidth:FIELD_WIDTH,ldapConfigurationContainer:this});this.sslTab=NX.create("Sonatype.repoServer.LdapConfigurationSSLCertificate",{title:"SSL",fieldWidth:FIELD_WIDTH,ldapConfigurationContainer:this});this.tabPanel=new Ext.TabPanel({activeTab:0,layoutOnTabChange:true,border:false,header:false,anchor:"100% 100%",deferredRender:false,defaults:{layout:"form",labelWidth:200,hideMode:"offsets",frame:true,border:false,autoScroll:true},items:[this.connectionConfigTab,this.mirrorConfigTab,this.userGroupConfigTab,this.sslTab],listeners:{tabchange:{fn:function(tabpanel,childpanel){childpanel.handleButtons()},scope:this}}});if(this.id.startsWith("new_")||!this.record.get("ldapUrl").startsWith("ldaps:")){this.tabPanel.on("afterrender",function(){Ext.defer(self.tabPanel.hideTabStripItem,100,self.tabPanel,[self.sslTab])},{single:true})}this.referenceData={name:"",connectionInfo:{searchBase:"",systemUsername:"",systemPassword:"",authScheme:"",protocol:"",host:"",port:0,backupMirrorProtocol:"",backupMirrorHost:"",backupMirrorPort:0,realm:"",connectionTimeout:0,connectionRetryDelay:0,cacheTimeout:0},userAndGroupConfig:{emailAddressAttribute:"",ldapGroupsAsRoles:false,groupBaseDn:"",groupIdAttribute:"",groupMemberAttribute:"",groupMemberFormat:"",groupObjectClass:"",userPasswordAttribute:"",userIdAttribute:"",userObjectClass:"",ldapFilter:"",userBaseDn:"",userRealNameAttribute:"",userSubtree:false,groupSubtree:false,userMemberOfAttribute:""}};this.formPanel=new Ext.form.FormPanel({border:false,frame:true,items:[this.tabPanel],buttonAlign:"center",buttons:[{text:"Check Authentication",handler:this.checkAuthenticationHandler,scope:this,hidden:true,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.EDIT)},{text:"Check User Mapping",handler:this.checkUserMappingHandler,scope:this,hidden:true,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.EDIT)},{text:"Check Login",handler:this.checkLoginHandler,scope:this,hidden:true,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.EDIT)},{text:"Save",handler:this.saveHandler,scope:this,disabled:!this.sp.checkPermission("security:ldapconfig",this.sp.CREATE)},{text:"Cancel",handler:this.cancelHandler,scope:this}]});Sonatype.repoServer.LdapConfiguration.superclass.constructor.call(this,{layout:"fit",border:false,items:[this.formPanel],listeners:{afterlayout:{fn:this.loadHandler,scope:this}}})},allTabsLoaded:function(){if(this.connectionConfigTab.isLoaded&&this.mirrorConfigTab.isLoaded&&this.userGroupConfigTab.isLoaded){return true}return false},layoutTabs:function(){this.connectionConfigTab.doLayout();this.mirrorConfigTab.doLayout();this.userGroupConfigTab.doLayout()},loadHandler:function(){if(this.isLoaded){return}if(!this.isLoading){this.isLoading=true;this.layoutTabs();if(!this.isNew){Sonatype.MessageBox.wait("Loading LDAP Configuration...")}}if(!this.allTabsLoaded()){this.loadHandler.defer(100,this);return}if(!this.isNew){this.formPanel.getForm().doAction("sonatypeLoad",{url:this.record.get("url"),method:"GET",fpanel:this,scope:this,dataModifiers:this.dataModifiers.load,success:function(form,action){this.connectionConfigTab.postLoad();this.mirrorConfigTab.postLoad();this.userGroupConfigTab.postLoad();this.isLoaded=true;Sonatype.MessageBox.hide()},failure:function(form,action){Sonatype.utils.connectionError(action.response,"Error Loading LDAP Configuration.")}})}else{this.connectionConfigTab.postLoad();this.mirrorConfigTab.postLoad();this.userGroupConfigTab.postLoad()}},saveHandler:function(){if(this.formPanel.getForm().isValid()){this.formPanel.getForm().doAction("sonatypeSubmit",{method:this.isNew?"POST":"PUT",url:this.isNew?Sonatype.config.servicePath+"/ldap/servers":this.record.get("url"),waitMsg:this.isNew?"Creating LDAP Server...":"Updating LDAP Server...",fpanel:this.formPanel,dataModifiers:this.dataModifiers.submit,serviceDataObj:this.referenceData,isNew:this.isNew,scope:this,success:function(form,action){if(this.ldapSaveCompleteHandler){this.ldapSaveCompleteHandler.call(this.ldapContainer,this,Ext.decode(action.response.responseText))}this.isNew=false;if(this.record.get("ldapUrl").startsWith("ldaps")){this.tabPanel.unhideTabStripItem(this.sslTab)}else{this.tabPanel.hideTabStripItem(this.sslTab)}},failure:function(form,action){Sonatype.utils.connectionError(action.response,"Error Saving LDAP Configuration.",false,{hideErrorStatus:true,decodeErrorResponse:true});action.result.errors=null}})}else{this.selectInvalidTab()}},cancelHandler:function(){if(this.ldapCancelHandler){this.ldapCancelHandler.call(this.ldapContainer,this)}},checkAuthenticationHandler:function(){var panel=this.tabPanel.getActiveTab();if(panel.getId()==this.connectionConfigTab.getId()){if(this.isPanelValid(this.connectionConfigTab)){this.connectionConfigTab.checkAuthentication()}}else{if(panel.getId()==this.mirrorConfigTab.getId()){if(!this.isPanelValid(this.connectionConfigTab)){this.tabPanel.setActiveTab(this.connectionConfigTab)}else{if(this.isPanelValid(this.mirrorConfigTab)){this.mirrorConfigTab.checkAuthentication()}}}}},checkUserMappingHandler:function(){if(this.formPanel.getForm().isValid()){this.userGroupConfigTab.checkUserMapping(this.formPanel,this.referenceData)}else{this.selectInvalidTab()}},checkLoginHandler:function(){if(this.formPanel.getForm().isValid()){this.userGroupConfigTab.checkLogin(this.formPanel,this.referenceData)}else{this.selectInvalidTab()}},selectInvalidTab:function(){var panel=this.tabPanel.getActiveTab();if(!this.isPanelValid(panel)){return}if(panel.getId()!=this.connectionConfigTab.getId()&&!this.isPanelValid(this.connectionConfigTab)){this.tabPanel.setActiveTab(this.connectionConfigTab)}else{if(panel.getId()!=this.mirrorConfigTab.getId()&&!this.isPanelValid(this.mirrorConfigTab)){this.tabPanel.setActiveTab(this.mirrorConfigTab)}else{if(panel.getId()!=this.userGroupConfigTab.getId()&&!this.isPanelValid(this.userGroupConfigTab)){this.tabPanel.setActiveTab(this.userGroupConfigTab)}}}},isPanelValid:function(panel){var items=panel.items.getRange();for(var i=0;i<items.length;i++){if(items[i].xtype=="fieldset"&&!this.isPanelValid(items[i])){return false}else{if(items[i].isValid&&!items[i].isValid()){return false}}}return true},expandHandler:function(panel){panel.items.each(function(item,i,len){if(item.getEl()!=null&&item.getEl().up("div.required-field",3)){item.allowBlank=false;item.clearInvalid()}else{item.allowBlank=true}},this)},collapseHandler:function(panel){panel.items.each(function(item,i,len){item.allowBlank=true},this)},dataModifiers:{load:{"connectionInfo.systemUsername":function(value){if(Ext.isDefined(value)){return Sonatype.utils.base64.decode(value)}return value},"connectionInfo.systemPassword":function(value){if(Ext.isDefined(value)){return Sonatype.utils.base64.decode(value)}return value}},submit:{"connectionInfo.systemUsername":function(value){if(Ext.isDefined(value)){return Sonatype.utils.base64.encode(value)}return value},"connectionInfo.systemPassword":function(value){if(Ext.isDefined(value)){return Sonatype.utils.base64.encode(value)}return value}}}});
NX.define("Sonatype.repoServer.LdapConfigurationSSLCertificate",{extend:"Nexus.ssl.AbstractCertificateTab",type:"ldap",title:"SSL",parseUrl:function(str){if(!str){return[]}var rx=/[^:]*:\/\/([^:\/]*)(:([0-9]*))?/,matches=str.match(rx);if(matches){return[matches[1],matches[3]]}return[str]},setCertRequestParams:function(){var self=this,hostParts=self.parseUrl(self.ldapConfigurationContainer.record.get("ldapUrl")),host=hostParts[0],port=hostParts[1]||636;self.certRequestParams={host:host,port:port,protocolHint:"ldaps"}},initComponent:function(){var self=this;self.data={id:self.ldapConfigurationContainer.record.get("id")};self.setCertRequestParams();self.constructor.superclass.initComponent.apply(self,arguments)},isSaved:function(){return !this.ldapConfigurationContainer.isNew},loadSettings:function(){var self=this;if(!self.isSaved()){return}if(self.data.id!==self.ldapConfigurationContainer.record.get("id")){self.data.id=self.ldapConfigurationContainer.record.get("id");self.setCertRequestParams()}self.constructor.superclass.loadSettings.apply(self,arguments)},hideButtons:function(panel,tab){if(this!==tab){Ext.each(this.ldapConfigurationContainer.formPanel.buttons,function(button){button.show()})}},handleButtons:function(){var self=this;self.ldapConfigurationContainer.tabPanel.on("beforetabchange",Ext.createDelegate(self.hideButtons,self));Ext.each(this.ldapConfigurationContainer.formPanel.buttons,function(button){button.hide()});this.items.get(0).setHeight(this.getHeight()-this.getFrameHeight())}});
